{if 'divider' === $field.type}
    <div class="w-100" {$field.style}></div>
{else}
    <div class="{$field.group_class}">

        {if 'select' === $field.type}
            {if !empty($field.label_inline)}
                <label for="{$field.id}">{$field.label_inline}</label>
            {/if}
            {if in_array('multiple', $field.atts)}
                <input type="hidden" name="{$field.name}" value="">
                {$field.name="`$field.name`[]"}
                {html_options id=$field.id class=$field.class name=$field.name options=$field.options selected=$field.selected multiple="multipe"}
            {else}
                {html_options id=$field.id class=$field.class name=$field.name options=$field.options selected=$field.selected}
            {/if}
        {/if}

        {if $field.type === 'text' || $field.type === 'url' || $field.type === 'tel' || $field.type === 'email' || $field.type === 'number'}
            {if !empty($field.label_inline)}
                <label for="{$field.id}">{$field.label_inline}</label>
            {/if}

            {if !empty($field.append)}<div class="input-group flex-nowrap input-group-sm">{/if}
            <input type="{$field.type}" class="{$field.class}" id="{$field.id}" name="{$field.name}" value="{$field.value}" placeholder="{$field.placeholder}" {' '|implode:$field.atts}>
            {if !empty($field.append)}
                <div class="input-group-append">
                    <span class="input-group-text">{$field.append}</span>
                </div>
            {/if}

            {if !empty($field.append)}</div>{/if}

            {if !empty($field.help)}
                <a href="#" class="twer-help-tooltip" data-toggle="tooltip" title="{$field.help}"><span class="dashicons dashicons-editor-help"></span></a>
            {/if}
        {/if}

        {if 'textarea' === $field.type}
            <textarea class="{$field.class}" name="{$field.name}" id="{$field.id}" placeholder="{$field.placeholder}" {' '|implode:$field.atts}>{$field.value}</textarea>
        {/if}

        {if 'range' === $field.type}
            <input type="range" name="{$field.name}" id="{$field.id}" value="{$field.value}" class="custom-range" {' '|implode:$field.atts}>
        {/if}

        {if 'checkbox' === $field.type}
            {if 'default' === $field.style}
                <div class="form-check">
                    <input type="hidden" name="{$field.name}" value="" {' '|implode:$field.atts}>
                    {html_checkboxes id=$field.id name=$field.name class="form-check-input" labels=false values=[true] checked=$field.checked}
                    {if !empty($field.label_inline)}
                        <label class="form-check-label" for="{$field.id}">
                            {$field.label_inline}
                        </label>
                    {/if}
                </div>
            {else}
                <label for="{$field.id}" class="{$field.class}">
                    <input type="hidden" name="{$field.name}" value="" {' '|implode:$field.atts}>
                    {if !empty($field.label_inline)}
                        <span class="twer-switcher__label">{$field.label_inline}</span>
                    {/if}
                    <span class="twer-switcher__inner">
                        {if in_array('disabled', $field.atts)}
                            {html_checkboxes id=$field.id name=$field.name labels=false values=[true] checked=$field.checked disabled="disabled"}
                        {else}
                            {html_checkboxes id=$field.id name=$field.name labels=false values=[true] checked=$field.checked}
                        {/if}
                        <span class="twer-switcher__slider"></span>
                    </span>
                </label>
            {/if}
        {/if}

        {if 'colorpicker' === $field.type}
            {if !empty($field.label_inline)}
                <label for="{$field.id}">{$field.label_inline}</label>
            {/if}
            <div class="twer-colorpicker js-twer-colorpicker">
                <input type="hidden" class="js-twer-colorpicker-color" id="{$field.id}" name="{$field.name}" value="{$field.value}">
                <input type="hidden" class="js-twer-colorpicker-custom-color" name="default_color" value="{$field.custom_colors}">
                <button class="btn btn-sm btn-outline-dark js-twer-color-picker-btn"><span class="twer-colorpicker__cell-color js-twer-colorpicker-cell" style="background-color: {$field.value};"></span>{$field.label_colorpicker}</button>
                <div class="twer-colorpicker__palette js-twer-colorpicker-palette" acp-palette="{$field.extends_colors}" data-default-palette="{$field.colors}"></div>
            </div>
        {/if}

        {if 'iconpicker' === $field.type}
            <input type="text" name="{$field.name}" hidden class="js-twer-iconpicker {$field.class}" id="{$field.id}" value="{$field.value}">
        {/if}

        {if 'image' === $field.type}
            <div class="twer-attach js-twer-attach-wrap">

                <div class="twer-attach__thumb js-twer-attach-thumb">
                    {if !empty($field.image)}
                        <img src="{$field.image}" alt="">
                    {/if}
                    <button type="button" class="btn btn-outline-light twer-attach__add-media js-twer-attach-add" style="{if !empty($field.value)}display:none;{else}display:block;{/if}">{$field.label_image_add}</button>
                    <input type="hidden" name="{$field.name}" id="{$field.id}" value="{$field.value}">
                </div>

                <div class="twer-attach__actions js-twer-attach-actions" style="{if !empty($field.value)}display:block;{else}display:none;{/if}">
                    <button type="button" class="button js-twer-attach-remove">{$field.label_image_remove}</button>
                    <button type="button" class="button js-twer-attach-add">{$field.label_image_change}</button>
                </div>
            </div>
        {/if}

        {if 'gallery' === $field.type}
            <div class="twer-attach-gallery js-twer-attach-gallery-wrap">
                {if !empty($field.gallery_images)}
                    {foreach $field.gallery_images as $thumb}
                        <div class="twer-attach-gallery__thumb" data-id="{$thumb}">
                            <a href="#" class="twer-attach-gallery__remove js-twer-attach-gallery-remove" title="{$field.label_image_remove}"></a>
                            <img src="{$thumb@key}" alt="{$thumb}">
                        </div>
                    {/foreach}
                {/if}
                <button type="button" class="btn btn-outline-light twer-attach-gallery__add-media js-twer-attach-gallery-add"></button>
                <input type="hidden" name="{$field.name}" value="{$field.value}">
            </div>
        {/if}

        {if 'button' === $field.type}
            <button type="button" class="{$field.class}">{$field.label_inline}</button>
        {/if}

        {if isset($field.extra)}
            <div class="form-extra d-none">
                {foreach $field.extra as $extra}
                    {include file='fields.tpl' field=$extra}
                {/foreach}
            </div>
        {/if}
    </div>
{/if}
